# Servicios criptográficos

The modules described in this chapter implement various algorithms of a cryptographic nature. They are available at the discretion of the installation. Here’s an overview:

- `hashlib` — Secure hashes and message digests
  - Algoritmos de hash
  - Usage
  - Constructors
  - Attributes
  - Hash Objects
  - Resúmenes SHAKE de largo variable
  - Cifrado de archivos
  - Derivación de clave
  - BLAKE2
    - Creando objetos hash
    - Constantes
    - Ejemplos
      - Cifrado simple
      - Usar diferentes tamaños de resumen
      - Cifrado de clave
      - Cifrado aleatorio
      - Personalización
      - Modo de árbol
    - Créditos
- `hmac` — Keyed-Hashing for Message Authentication
- `secrets` — Generate secure random numbers for managing secrets
  - Números aleatorios
  - Generando tokens
    - ¿Cuántos bytes deben tener los tokens?
  - Otras funciones
  - Recetas y mejores prácticas